
/******************************************************
 *                    Let's GO !!! PIC                *
 *                    capitolo quarto                 *
 *                    17 dicenbre 2010                *
 *   USO DELLA PORTA SERIALE PER IL DISPLAY 7-SEG     *
 *      RS232 Acquisizione seriale dati numerici      *
 * con XP usare hyperterminal e inviare ASCIIn cifre  *
 *        @P123 ret  spegne LED di test               *
 *        @Q123 ret  riaccende LED di test            *
 *             attenzione:P e Q maiscoli              *
 *  Versione con CD4511 ottimizzata per Micro-GT IDE  *
 *****************************************************/

#include "pic.h"
#include "delay.h"
unsigned char C1,C2,C3,C4,Valore,Flags;

extern void Par_ser(void); //predichiarazione della funzione o prototipo
						   //utile quando il corpo della funzione si trova sotto la funzione main
						   //o sotto la chiamata		
    
main(void){
TRISA = 0x00;	    // tutte uscite per evitare interferenze
TRISB = 0x00; 	    // tutte uscite 
TRISC = 0xf8;		// bit 6-7 Seriale
TRISD = 0x00;       // tutte uscite
PORTA = 0x01;		// azzera i pin del PORT A ma accende il primo LED port A
PORTB = 0x00;	    // azzera i pin del PORT B
PORTC = 0x00;       // azzera i pin del PORT C
PORTD = 0x01;		// D0 si attiva alla prima scansione
ADCON1= 0x87;		// PORTA all digital mode

//Inizializzazione uart
TXSTA= 0x20;	 // TX abilitato
RCSTA= 0X90;	 // Registro RX USART
BRGH = 1;		 // USART High velocity
SPBRG= 25;		 // Baud Rate Generator (25=9600 baud)

//Inizializzazione TIMER1
T1CON   = 0;		// TIMER 1 resettato
T1CKPS1 = 0,T1CKPS0=0;	// TIMER1 prescaler = 1
T1OSCEN = 0;		// TIMER1 external oscillator disable
TMR1CS  = 0;		// TIMER1 internal clock (fosc/4)
TMR1ON  = 0;		// TIMER1 in STOP

//Inizializzazione interrupt
INTCON = 0;		// Interrupt disabilitato
PIE1   = 0;		// Interrupt di periferica disabilitati
GIE    = 1;		// Global Interrupt Enable
PEIE   = 1;		// Periferal Interrupt Enable
RCIE   = 1;		// USART Receive Interrupt Enable

}

void interrupt SerChar(void)    //prototipo ricezione
{
  if (RCREG==0x40 | Valore > 6)  //se arriva la chiocciola dimensiona la stringa
   {
   C1=0,C2=0,C3=0,C4=0;		//azzero la stringa
   Valore=0,Flags=0;
   }
  if (Valore==1) C1=RCREG;	//ricezione della stringa comandi
  if (Valore==2) C2=RCREG; 
  if (Valore==3) C3=RCREG;
  if (Valore==4) C4=RCREG;
  if ((Valore==5 )&& (RCREG==0x0d)) Flags=1; // <CR> terminatore di stringa
  Valore++;
 if (Flags==1) Par_ser(); //lancia analisi della stringa ricevuta
}

void
Par_ser(void)		       // Analisi comandi
{
 Flags=0;
 switch (C1)
  {
  case 0x41:    //carattere A
   PORTD = 0x2;	//carattere A attiva D1
   break; 
   case 0x51: //carattere Q maiscolo accende LED test seriale
   PORTD = 0x01; 
   break; 
   case 0x50: //carattere P maiscolo spegne LED test seriale
   PORTD = 0x00; 
   break; 
   case 0x30: //carattere numero 0
   PORTB=0b00000001; 
   break; 
   case 0x31: //carattere numero 1
   PORTB=0b00010001; 
   break; 
   case 0x32: //carattere numero 2
   PORTB=0b00100001; 
   break; 
   case 0x33: //carattere numero 3
   PORTB=0b00110001; 
   break;
   case 0x34: //carattere numero 4
   PORTB=0b01000001; 
   break; 
   case 0x35: //carattere numero 5
   PORTB=0b01010001; 
   break; 
   case 0x36: //carattere numero 6
   PORTB=0b01100001; 
   break; 
   case 0x37: //carattere numero 7
   PORTB=0b01110001; 
   break; 
   case 0x38: //carattere numero 8
   PORTB=0b10000001; 
   break; 
   case 0x39: //carattere numero 9
   PORTB=0b10010001; 
   break;  
  }
}
